#include <libk/std.h>
#include <libk/string.h>

size_t memset (void* dst, uint8_t b, size_t n) {
  uint8_t* dst1 = dst;
  size_t i;
  for (i = 0; i < n; i++)
    dst1[i] = b;
  return i;
}

size_t memcpy (void* dst, const void* src, size_t n) {
  uint8_t* dst1 = dst;
  const uint8_t* src1 = src;
  size_t i;
  for (i = 0; i < n; i++)
    dst1[i] = src1[i];
  return i;
}

// SOURCE: https://stackoverflow.com/a/48967408
void strncpy (char* dst, const char* src, size_t n) {
  size_t i = 0;
  while (i++ != n && (*dst++ = *src++))
    ;
}

size_t strlen (const char* str) {
  const char* s;
  for (s = str; *s; ++s)
    ;
  return (s - str);
}

int memcmp (const void* s1, const void* s2, size_t n) {
  unsigned char* p = (unsigned char*)s1;
  unsigned char* q = (unsigned char*)s2;

  while (n--) {
    if (*p != *q) {
      return (int)*p - (int)*q;
    }
    p++, q++;
  }
  return 0;
}
